echo off

Cls
if exist %2\TCC.EXE goto cont1
echo -------------------------------------------------------------------------
echo - ** ERROR IN PARAMETER #2 ** Unable to locate TCC.EXE in directory:
echo - [%2]
goto cont3
:cont1
if not "%4"=="" goto cont2
echo -------------------------------------------------------------------------
echo - ** ERROR IN PARAMETER #3 ** Please specify a drive and directory where
echo - the turbo c library files will be stored.
goto cont3
:cont2
if "%1" == "M" goto medium
if "%1" == "C" goto compact
if "%1" == "L" goto large
if "%1" == "H" goto huge
if "%1" == "ALL" goto all
if "%1" == "m" goto medium
if "%1" == "c" goto compact
if "%1" == "l" goto large
if "%1" == "h" goto huge
if "%1" == "all" goto all
echo -------------------------------------------------------------------------
echo - ** ERROR IN PARAMETER #1 ** "%1" is an invalid selection for memory
echo - model - please check format and try again.
:cont3
echo -------------------------------------------------------------------------
echo - This batch file will execute the Turbo C command line compiler (TCC.EXE)
echo - and compile the source files ScrEdit.C, Validate.C, ScrMouse.C, and
echo - Windows.C (registered version only), into object files. It then uses
echo - the Turbo Linker (TLIB) and builds the library files  ScrEdit?.Lib and
echo - Windows?.Lib (registered verson only.)
echo -
echo - Format: LibBuild Option  Path-1  Path-2  Path-3
echo -                  ------  ------  ------  ------
echo - Option:  (M)EDIUM  (C)OMPACT  (L)ARGE  (H)UGE  (ALL) four models.
echo - Path-1:  Drive:\Path where TCC.EXE resides.
echo -                Normally:(Hard Dr) C:\Tc   (Floppy) A:
echo - Path-2:  Drive:\Path where the Turbo C library and include files reside.
echo -                Normally:(Hard Dr) C:\Tc   (Floppy) B:\
echo - Path-3:  Drive:\Path where the generated library files are to be stored.
echo -                Recommend:(Hard Dr) C:\Tc\Lib  (Floppy) B:\Lib
echo -
echo - Example - LibBuild All C:\Tc C:\Tc C:\Tc\Lib
echo -------------------------------------------------------------------------
goto end2
:all
:medium
echo on
if exist %4\screditm.lib del %4\screditm.lib
if exist %4\windowsm.lib del %4\windowsM.Lib
echo on
%2\Tcc -mm  -c -d -oScrEdit.ObJ -I%3\INCLUDE -L%3\Lib Scredit.c
%2\Tlib %4\screditm.lib +scredit.obj
echo off
del scredit.obj
if not exist windows.c goto skipM
echo on
%2\Tcc -mm  -c -d -owindows.ObJ -I%3\INCLUDE -L%3\Lib windows.c
%2\tlib %4\windowsM.lib + windows.obj
echo off
del windows.obj
:skipM
if "%1" == "M" goto end
if "%1" == "m" goto end
:compact
if  exist %4\screditc.lib del %4\screditc.lib
if  exist %4\windowsC.lib del %4\windowsC.Lib
echo on
%2\Tcc -mc  -c -d -oScrEdit.ObJ -I%3\INCLUDE -L%3\Lib Scredit.c
%2\Tlib %4\screditC.lib +scredit.obj
echo off
del scredit.obj
if not exist windows.c goto skipC
echo on
%2\Tcc -mc  -c -d -owindows.ObJ -I%3\INCLUDE -L%3\Lib windows.c
%2\tlib %4\windowsC.lib + windows.obj
echo off
del windows.obj
:skipC
if "%1" == "C" goto end
if "%1" == "c" goto end
:large
if  exist %4\screditl.lib del %4\screditl.lib
if  exist %4\windowsl.lib del %4\windowsL.Lib
echo on
%2\Tcc -ml  -c -d -oScrEdit.ObJ -I%3\INCLUDE -L%3\Lib Scredit.c
%2\Tlib %4\screditl.lib +scredit.obj
echo off
del scredit.obj
if not exist windows.c goto skipL
echo on
%2\Tcc -ml  -c -d -owindows.ObJ -I%3\INCLUDE -L%3\Lib windows.c
%2\Tlib %4\windowsL.lib + windows.obj
echo off
del windows.obj
:skipL
if "%1" == "L" goto end
if "%1" == "l" goto end
:huge
if exist %4\scredith.lib del %4\screditH.lib
if exist %4\windowsh.lib del %4\windowsH.Lib
echo on
%2\Tcc -mh  -c -d -oScrEdit.ObJ -I%3\INCLUDE -L%3\Lib Scredit.c
%2\Tlib %4\scredith.lib +scredit.obj
echo off
del scredit.obj
if not exist windows.c goto skipH
echo on
%2\Tcc -mh  -c -d -owindows.ObJ -I%3\INCLUDE -L%3\Lib windows.c
%2\tlib %4\windowsH.lib + windows.obj
echo off
del windows.obj
echo -
:skipH
:end
if exist windows.c goto done
echo ------------------------------------------------------------------------
echo ***    Evaluation version does not include pop up windows library    ***
echo ------------------------------------------------------------------------
:done
echo -
echo - Turbo ScrEdit Library Build ** Completed **
:End2
